/******************************************************************************
*
* Copyright (C) 2002 Hugo PEREIRA <mailto: hugo.pereira@free.fr>
*
* This is free software; you can redistribute it and/or modify it under the
* terms of the GNU General Public License as published by the Free Software
* Foundation; either version 2 of the License, or (at your option) any later
* version.
*
* This software is distributed in the hope that it will be useful, but WITHOUT
* Any WARRANTY; without even the implied warranty of MERCHANTABILITY or
* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
* for more details.
*
* You should have received a copy of the GNU General Public License along with
* this program.  If not, see <http://www.gnu.org/licenses/>.
*
*******************************************************************************/

#include "Application.h"
#include "Debug.h"
#include "DebugMenu.h"
#include "IconEngine.h"
#include "Menu.h"
#include "QtUtil.h"
#include "Singleton.h"
#include "Util.h"
#include "XmlOptions.h"

#include <QApplication>

//__________________________________________________
Menu::Menu( QWidget* parent ):
    QMenu( parent ),
    Counter( "Menu" )
{

    Debug::Throw( "Menu::Menu" );

    // title
    QtUtil::addMenuSection( this, windowIcon(), "Qssh" );

    auto application( Singleton::get().application<Application>() );

    addAction( &application->aboutAction() );
    addAction( &application->aboutQtAction() );
    DebugMenu *debugMenu( new DebugMenu( this ) );
    addAction( debugMenu->menuAction() );
    debugMenu->menuAction()->setVisible( false );

    addSeparator();
    addAction( &application->configurationAction() );

    separator_ = addSeparator();
    addAction( &application->closeAction() );

}
